Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3291)
+++ palm/trunk/SOURCE/parin.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -471,4 +474,7 @@
         ONLY:  netcdf_data_format, netcdf_deflate, netcdf_precision
 
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_parin
+
     USE pegrid
                
@@ -527,6 +533,6 @@
     NAMELIST /inipar/  alpha_surface, approximation, bc_e_b,     &
                        bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b, &
-             bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,                 &
-             bottom_salinityflux, building_height, building_length_x,          &
+             bc_q_t,bc_s_b, bc_s_t, bc_uv_b, bc_uv_t,                 &
+             building_height, building_length_x,          &
              building_length_y, building_wall_left, building_wall_south,       &
              calc_soil_moisture_during_spinup,                                 &
@@ -559,6 +565,6 @@
              most_method, nesting_offline,                  &
              netcdf_precision, neutral, ngsrb,                                 &
-             nsor, nsor_ini, nudging, nx, ny, nz, ocean, omega, omega_sor,     &
-             outflow_source_plane, passive_scalar,                             &
+             nsor, nsor_ini, nudging, nx, ny, nz, ocean_mode, omega,           &
+             omega_sor, outflow_source_plane, passive_scalar,                  &
              prandtl_number, psolver, pt_damping_factor,        &
              pt_damping_width, pt_reference, pt_surface,                       &
@@ -571,6 +577,6 @@
              recycling_width, recycling_yshift,                                &
              reference_state, residual_limit,                                  &
-             roughness_length, sa_surface,                                     &
-             sa_vertical_gradient, sa_vertical_gradient_level, scalar_advec,   &
+             roughness_length,                                                 &
+             scalar_advec,   &
              scalar_rayleigh_damping,                              &
              spinup_time, spinup_pt_amplitude, spinup_pt_mean,                 &
@@ -581,5 +587,5 @@
              s_vertical_gradient_level, time_utc_init, timestep_scheme,        &
              topography, topography_grid_convention, top_heatflux,             &
-             top_momentumflux_u, top_momentumflux_v, top_salinityflux,         &
+             top_momentumflux_u, top_momentumflux_v,                           &
              top_scalarflux, transpose_compute_overlap,                        &
              tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y,     &
@@ -593,28 +599,28 @@
              vg_vertical_gradient_level, v_bulk, v_profile,&
              wall_adjustment, wall_heatflux, wall_humidityflux,                &
-             wall_salinityflux, wall_scalarflux, y_shift, zeta_max, zeta_min,  &
+             wall_scalarflux, y_shift, zeta_max, zeta_min,  &
              z0h_factor
 
-    NAMELIST /initialization_parameters/  alpha_surface,         &
+    NAMELIST /initialization_parameters/  alpha_surface,                       &
              approximation, bc_e_b,                                            &
              bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b,           &
-             bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,                 &
-             bottom_salinityflux, building_height, building_length_x,          &
+             bc_q_t,bc_s_b, bc_s_t, bc_uv_b, bc_uv_t,                          &
+             building_height, building_length_x,                               &
              building_length_y, building_wall_left, building_wall_south,       &
              calc_soil_moisture_during_spinup,                                 &
-             call_psolver_at_all_substeps,  &
+             call_psolver_at_all_substeps,                                     &
              canyon_height,                                                    &
              canyon_width_x, canyon_width_y, canyon_wall_left,                 &
-             canyon_wall_south, cfl_factor, cloud_droplets,   &
-             cloud_top_radiation,                 &
-             collective_wait, complex_terrain,           &
+             canyon_wall_south, cfl_factor, cloud_droplets,                    &
+             cloud_top_radiation,                                              &
+             collective_wait, complex_terrain,                                 &
              conserve_volume_flow,                                             &
              conserve_volume_flow_mode, constant_flux_layer,                   &
-             coupling_start_time,             &
+             coupling_start_time,                                              &
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
              day_of_year_init,                                                 &
              dissipation_1d,                                                   &
-             dp_external, dp_level_b, dp_smooth, dpdxy,    &
+             dp_external, dp_level_b, dp_smooth, dpdxy,                        &
              dt, dt_pr_1d, dt_run_control_1d, dt_spinup, dx, dy, dz, dz_max,   &
              dz_stretch_factor, dz_stretch_level, dz_stretch_level_start,      &
@@ -626,12 +632,12 @@
              initializing_actions, km_constant,                                &
              large_scale_forcing, large_scale_subsidence, latitude,            &
-             longitude,                                 &
+             longitude,                                                        &
              loop_optimization, lsf_exception, masking_method, mg_cycles,      &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec,         &
-             most_method, nesting_offline,                  &
+             most_method, nesting_offline,                                     &
              netcdf_precision, neutral, ngsrb,                                 &
-             nsor, nsor_ini, nudging, nx, ny, nz, ocean, omega, omega_sor,     &
-             outflow_source_plane, passive_scalar,                             &
-             prandtl_number, psolver, pt_damping_factor,        &
+             nsor, nsor_ini, nudging, nx, ny, nz, ocean_mode, omega,           &
+             omega_sor, outflow_source_plane, passive_scalar,                  &
+             prandtl_number, psolver, pt_damping_factor,                       &
              pt_damping_width, pt_reference, pt_surface,                       &
              pt_surface_initial_change, pt_vertical_gradient,                  &
@@ -643,7 +649,6 @@
              recycling_width, recycling_yshift,                                &
              reference_state, residual_limit,                                  &
-             roughness_length, sa_surface,                                     &
-             sa_vertical_gradient, sa_vertical_gradient_level, scalar_advec,   &
-             scalar_rayleigh_damping,                              &
+             roughness_length, scalar_advec,                                   &
+             scalar_rayleigh_damping,                                          &
              spinup_time, spinup_pt_amplitude, spinup_pt_mean,                 &
              statistic_regions, subs_vertical_gradient,                        &
@@ -653,5 +658,5 @@
              s_vertical_gradient_level, time_utc_init, timestep_scheme,        &
              topography, topography_grid_convention, top_heatflux,             &
-             top_momentumflux_u, top_momentumflux_v, top_salinityflux,         &
+             top_momentumflux_u, top_momentumflux_v,                           &
              top_scalarflux, transpose_compute_overlap,                        &
              tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y,     &
@@ -663,8 +668,7 @@
              use_free_convection_scaling,                                      &
              uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient,  &
-             vg_vertical_gradient_level, v_bulk, v_profile,&
+             vg_vertical_gradient_level, v_bulk, v_profile,                    &
              wall_adjustment, wall_heatflux, wall_humidityflux,                &
-             wall_salinityflux, wall_scalarflux, y_shift, zeta_max, zeta_min,  &
-             z0h_factor
+             wall_scalarflux, y_shift, zeta_max, zeta_min, z0h_factor
              
     NAMELIST /d3par/  averaging_interval, averaging_interval_pr,               &
@@ -858,56 +862,19 @@
 
 !
-!--       Check if land surface model is used and read &lsm_par if required
+!--       Check for module namelists and read them
           CALL lsm_parin
-
-!
-!--       Check if gust module is used and read &gust_par if required
           CALL bcm_parin
-
-!
-!--       Check if urban surface model is used and read &urban_surface_par if required
           CALL usm_parin
-
-!
-!--       Check if spectra shall be calculated and read spectra_par if required
           CALL spectra_parin
-
-!
-!--       Check if radiation model is used and read &radiation_par if required
           CALL radiation_parin
-
-!
-!--       Check if gust module is used and read &gust_par if required
           CALL gust_parin
-
-!
-!--       Check if multi agent system is used and read &agents_par if required
           CALL mas_parin
-
-!
-!--       Check if plant canopy model is used and read &canopy_par if required
+          CALL ocean_parin
           CALL pcm_parin
-
-!
-!--       Read control parameters for optionally used model software packages
           CALL package_parin
-
-!
-!--       Check if wind turbine model is used and read &wind_turbine_par if
-!--       required
           CALL wtm_parin
-!
-!--       Check if virtual flights should be carried out and read &flight_par
-!--       if required
           CALL flight_parin
-!
-!--       Check if synthetic turbulence generator is used and read stg_par if
-!--       required
           CALL stg_parin
-!
-!--       Read chemistry variables
           CALL chem_parin
-!
-!--       Check if uv exposure model is used and read &uvexposure_par
           CALL uvem_parin
 !
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -685,5 +688,5 @@
 
        USE control_parameters,                                                 &
-           ONLY: humidity, message_string, ocean, urban_surface
+           ONLY: humidity, message_string, ocean_mode, urban_surface
 
        USE netcdf_data_input_mod,                                              &
@@ -732,5 +735,5 @@
           gradient = 0.0_wp
 
-          IF (  .NOT.  ocean )  THEN
+          IF (  .NOT.  ocean_mode )  THEN
 
              lad(0) = lad_surface
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3291)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -277,4 +280,33 @@
 
 
+    USE advec_s_bc_mod,                                                        &
+        ONLY:  advec_s_bc
+
+    USE advec_s_pw_mod,                                                        &
+        ONLY:  advec_s_pw
+
+    USE advec_s_up_mod,                                                        &
+        ONLY:  advec_s_up
+
+    USE advec_u_pw_mod,                                                        &
+        ONLY:  advec_u_pw
+
+    USE advec_u_up_mod,                                                        &
+        ONLY:  advec_u_up
+
+    USE advec_v_pw_mod,                                                        &
+        ONLY:  advec_v_pw
+
+    USE advec_v_up_mod,                                                        &
+        ONLY:  advec_v_up
+
+    USE advec_w_pw_mod,                                                        &
+        ONLY:  advec_w_pw
+
+    USE advec_w_up_mod,                                                        &
+        ONLY:  advec_w_up
+
+    USE advec_ws,                                                              &
+        ONLY:  advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws
 
     USE arrays_3d,                                                             &
@@ -287,8 +319,7 @@
                flux_l_sa, nc, nc_p, nr, nr_p, pt, ptdf_x, ptdf_y, pt_init,     &
                pt_p, prho, q, q_init, q_p, qc, qc_p, qr, qr_p, rdf, rdf_sc,    &
-               ref_state, rho_ocean, s,  s_init, s_p, sa, sa_init, sa_p, tend, &
-               te_m, tnc_m,  tnr_m, tpt_m, tq_m, tqc_m, tqr_m, ts_m, tsa_m,    &
-               tu_m, tv_m, tw_m, u, ug, u_init, u_p, v, vg, vpt, v_init, v_p,  &
-               w, w_p
+               ref_state, rho_ocean, s, s_init, s_p, tend, te_m, tnc_m,        &
+               tnr_m, tpt_m, tq_m, tqc_m, tqr_m, ts_m, tu_m, tv_m, tw_m, u,    &
+               ug, u_init, u_p, v, vg, vpt, v_init, v_p, w, w_p
 
     USE bulk_cloud_model_mod,                                                  &
@@ -297,13 +328,19 @@
                microphysics_morrison, microphysics_seifert
 
+    USE buoyancy_mod,                                                          &
+        ONLY:  buoyancy
+
+    USE calc_radiation_mod,                                                    &
+        ONLY:  calc_radiation
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_integrate, chem_prognostic_equations,                      &
                chem_species, nspec, nvar, spc_names
            
+    USE chem_modules,                                                          &
+        ONLY:  call_chem_at_all_substeps, chem_gasphase_on
+
     USE chem_photolysis_mod,                                                   &
         ONLY:  photolysis_control
-
-    USE chem_modules,                                                          &
-        ONLY:  call_chem_at_all_substeps, chem_gasphase_on
 
     USE control_parameters,                                                    &
@@ -315,7 +352,5 @@
                large_scale_subsidence,                  &
                neutral, nudging, &
-               ocean, passive_scalar, plant_canopy,                            &
-               prho_reference, prho_reference,                                 &
-               prho_reference, pt_reference, pt_reference, pt_reference,       &
+               ocean_mode, passive_scalar, plant_canopy, pt_reference,         &
                scalar_advec, scalar_advec, simulated_time, sloping_surface,    &
                timestep_scheme, tsc, use_subsidence_tendencies,                &
@@ -323,10 +358,21 @@
                ws_scheme_sca, urban_surface, land_surface
 
+    USE coriolis_mod,                                                          &
+        ONLY:  coriolis
+
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point, log_point_s
 
-
-    USE eqn_state_seawater_mod,                                                &
-        ONLY:  eqn_state_seawater
+    USE diffusion_s_mod,                                                       &
+        ONLY:  diffusion_s
+
+    USE diffusion_u_mod,                                                       &
+        ONLY:  diffusion_u
+
+    USE diffusion_v_mod,                                                       &
+        ONLY:  diffusion_v
+
+    USE diffusion_w_mod,                                                       &
+        ONLY:  diffusion_w
 
     USE indices,                                                               &
@@ -334,59 +380,11 @@
                nzb, nzt, wall_flags_0
 
-    USE advec_ws,                                                              &
-        ONLY:  advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws
-
-    USE advec_s_bc_mod,                                                        &
-        ONLY:  advec_s_bc
-
-    USE advec_s_pw_mod,                                                        &
-        ONLY:  advec_s_pw
-
-    USE advec_s_up_mod,                                                        &
-        ONLY:  advec_s_up
-
-    USE advec_u_pw_mod,                                                        &
-        ONLY:  advec_u_pw
-
-    USE advec_u_up_mod,                                                        &
-        ONLY:  advec_u_up
-
-    USE advec_v_pw_mod,                                                        &
-        ONLY:  advec_v_pw
-
-    USE advec_v_up_mod,                                                        &
-        ONLY:  advec_v_up
-
-    USE advec_w_pw_mod,                                                        &
-        ONLY:  advec_w_pw
-
-    USE advec_w_up_mod,                                                        &
-        ONLY:  advec_w_up
-
-    USE buoyancy_mod,                                                          &
-        ONLY:  buoyancy
-
-    USE calc_radiation_mod,                                                    &
-        ONLY:  calc_radiation
-
-    USE coriolis_mod,                                                          &
-        ONLY:  coriolis
-
-    USE diffusion_s_mod,                                                       &
-        ONLY:  diffusion_s
-
-    USE diffusion_u_mod,                                                       &
-        ONLY:  diffusion_u
-
-    USE diffusion_v_mod,                                                       &
-        ONLY:  diffusion_v
-
-    USE diffusion_w_mod,                                                       &
-        ONLY:  diffusion_w
-
     USE kinds
 
     USE lsf_nudging_mod,                                                       &
         ONLY:  ls_advec, nudge
+
+    USE ocean_mod,                                                             &
+        ONLY:  eqn_state_seawater, ocean_prognostic_equations
 
     USE plant_canopy_model_mod,                                                &
@@ -403,4 +401,8 @@
         ONLY:  subsidence
 
+    USE surface_mod,                                                           &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
+                surf_usm_v
+
     USE turbulence_closure_mod,                                                &
         ONLY:  tcm_prognostic
@@ -408,8 +410,4 @@
     USE user_actions_mod,                                                      &
         ONLY:  user_actions
-
-    USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
-                surf_usm_v 
 
     USE wind_turbine_model_mod,                                                &
@@ -699,5 +697,5 @@
 
           IF ( .NOT. neutral )  THEN
-             IF ( ocean )  THEN
+             IF ( ocean_mode )  THEN
                 CALL buoyancy( i, j, rho_ocean, 3 )
              ELSE
@@ -844,71 +842,4 @@
                 ENDIF
              ENDIF
-
-          ENDIF
-
-!
-!--       If required, compute prognostic equation for salinity
-          IF ( ocean )  THEN
-
-!
-!--          Tendency-terms for salinity
-             tend(:,j,i) = 0.0_wp
-             IF ( timestep_scheme(1:5) == 'runge' ) &
-             THEN
-                IF ( ws_scheme_sca )  THEN
-                    CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  &
-                                diss_s_sa, flux_l_sa, diss_l_sa, i_omp_start, tn  )
-                ELSE
-                    CALL advec_s_pw( i, j, sa )
-                ENDIF
-             ELSE
-                CALL advec_s_up( i, j, sa )
-             ENDIF
-             CALL diffusion_s( i, j, sa,                                       &
-                               surf_def_h(0)%sasws, surf_def_h(1)%sasws,       &
-                               surf_def_h(2)%sasws,                            &
-                               surf_lsm_h%sasws,    surf_usm_h%sasws,          & 
-                               surf_def_v(0)%sasws, surf_def_v(1)%sasws,       &
-                               surf_def_v(2)%sasws, surf_def_v(3)%sasws,       &
-                               surf_lsm_v(0)%sasws, surf_lsm_v(1)%sasws,       &
-                               surf_lsm_v(2)%sasws, surf_lsm_v(3)%sasws,       &
-                               surf_usm_v(0)%sasws, surf_usm_v(1)%sasws,       &
-                               surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
-
-             CALL user_actions( i, j, 'sa-tendency' )
-
-!
-!--          Prognostic equation for salinity
-             DO  k = nzb+1, nzt
-                sa_p(k,j,i) = sa(k,j,i) + ( dt_3d *                            &
-                                                  ( tsc(2) * tend(k,j,i) +     &
-                                                    tsc(3) * tsa_m(k,j,i) )    &
-                                                  - tsc(5) * rdf_sc(k)         &
-                                                   * ( sa(k,j,i) - sa_init(k) )&
-                                          ) * MERGE( 1.0_wp, 0.0_wp,           &
-                                                BTEST( wall_flags_0(k,j,i), 0 )&
-                                                   )
-                IF ( sa_p(k,j,i) < 0.0_wp )  sa_p(k,j,i) = 0.1_wp * sa(k,j,i)
-             ENDDO
-
-!
-!--          Calculate tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb+1, nzt
-                      tsa_m(k,j,i) = tend(k,j,i)
-                   ENDDO
-                ELSEIF ( intermediate_timestep_count < &
-                         intermediate_timestep_count_max )  THEN
-                   DO  k = nzb+1, nzt
-                      tsa_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
-                                        5.3125_wp * tsa_m(k,j,i)
-                   ENDDO  
-                ENDIF
-             ENDIF
-
-!
-!--          Calculate density by the equation of state for seawater
-             CALL eqn_state_seawater( i, j )
 
           ENDIF
@@ -1324,11 +1255,12 @@
 
 !
-!--       If required, compute prognostic equation for chemical quantites
+!--       Calculate prognostic equation for chemical quantites
           IF ( air_chemistry )  THEN
+             !> TODO: remove time measurement since it slows down performance because it will be called extremely often
              CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'start' )
 !
 !--          Loop over chemical species
              DO  lsp = 1, nvar                         
-                CALL chem_prognostic_equations ( chem_species(lsp)%conc_p,     &
+                CALL chem_prognostic_equations( chem_species(lsp)%conc_p,      &
                                      chem_species(lsp)%conc,                   &
                                      chem_species(lsp)%tconc_m,                &
@@ -1342,8 +1274,13 @@
 
              CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'stop' )             
-          ENDIF   ! Chemicals equations                     
-
-       ENDDO
-    ENDDO
+          ENDIF   ! Chemical equations
+!
+!--       Calculate prognostic equations for the ocean
+          IF ( ocean_mode )  THEN
+             CALL ocean_prognostic_equations( i, j, i_omp_start, tn )
+          ENDIF
+
+       ENDDO  ! loop over j
+    ENDDO  ! loop over i
     !$OMP END PARALLEL
 
@@ -1576,5 +1513,5 @@
 
     IF ( .NOT. neutral )  THEN
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           CALL buoyancy( rho_ocean, 3 )
        ELSE
@@ -1770,105 +1707,4 @@
 
 !
-!-- If required, compute prognostic equation for salinity
-    IF ( ocean )  THEN
-
-       CALL cpu_log( log_point(37), 'sa-equation', 'start' )
-
-!
-!--    sa-tendency terms with communication
-       sbt = tsc(2)
-       IF ( scalar_advec == 'bc-scheme' )  THEN
-
-          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
-!
-!--          Bott-Chlond scheme always uses Euler time step. Thus:
-             sbt = 1.0_wp
-          ENDIF
-          tend = 0.0_wp
-          CALL advec_s_bc( sa, 'sa' )
-
-       ENDIF
-
-!
-!--    sa-tendency terms with no communication
-       IF ( scalar_advec /= 'bc-scheme' )  THEN
-          tend = 0.0_wp
-          IF ( timestep_scheme(1:5) == 'runge' )  THEN
-             IF ( ws_scheme_sca )  THEN
-                 CALL advec_s_ws( sa, 'sa' )
-             ELSE
-                 CALL advec_s_pw( sa )
-             ENDIF
-          ELSE
-             CALL advec_s_up( sa )
-          ENDIF
-       ENDIF
-
-       CALL diffusion_s( sa,                                                   &
-                         surf_def_h(0)%sasws, surf_def_h(1)%sasws,             &
-                         surf_def_h(2)%sasws,                                  &
-                         surf_lsm_h%sasws,    surf_usm_h%sasws,                &
-                         surf_def_v(0)%sasws, surf_def_v(1)%sasws,             &
-                         surf_def_v(2)%sasws, surf_def_v(3)%sasws,             &
-                         surf_lsm_v(0)%sasws, surf_lsm_v(1)%sasws,             &
-                         surf_lsm_v(2)%sasws, surf_lsm_v(3)%sasws,             &
-                         surf_usm_v(0)%sasws, surf_usm_v(1)%sasws,             &
-                         surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
-
-       CALL user_actions( 'sa-tendency' )
-
-!
-!--    Prognostic equation for salinity
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                sa_p(k,j,i) = sa(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +      &
-                                                   tsc(3) * tsa_m(k,j,i) )     &
-                                                 - tsc(5) * rdf_sc(k) *        &
-                                                 ( sa(k,j,i) - sa_init(k) )    &
-                                          )                                    &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_0(k,j,i), 0 )   &
-                                          )
-                IF ( sa_p(k,j,i) < 0.0_wp )  sa_p(k,j,i) = 0.1_wp * sa(k,j,i)
-             ENDDO
-          ENDDO
-       ENDDO
-
-!
-!--    Calculate tendencies for the next Runge-Kutta step
-       IF ( timestep_scheme(1:5) == 'runge' )  THEN
-          IF ( intermediate_timestep_count == 1 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb+1, nzt
-                      tsa_m(k,j,i) = tend(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-                   intermediate_timestep_count_max )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb+1, nzt
-                      tsa_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
-                                        5.3125_wp * tsa_m(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       ENDIF
-
-       CALL cpu_log( log_point(37), 'sa-equation', 'stop' )
-
-!
-!--    Calculate density by the equation of state for seawater
-       CALL cpu_log( log_point(38), 'eqns-seawater', 'start' )
-       CALL eqn_state_seawater
-       CALL cpu_log( log_point(38), 'eqns-seawater', 'stop' )
-
-    ENDIF
-
-!
 !-- If required, compute prognostic equation for total water content
     IF ( humidity )  THEN
@@ -2074,6 +1910,6 @@
 
           CALL cpu_log( log_point(67), 'qc-equation', 'stop' )
+
           CALL cpu_log( log_point(68), 'nc-equation', 'start' )
-
 !
 !--       Calculate prognostic equation for cloud drop concentration
@@ -2461,8 +2297,10 @@
     ENDIF
 
+!
+!-- Calculate prognostic equations for turbulence closure
     CALL tcm_prognostic()
 
 !
-!-- If required, compute prognostic equation for chemical quantites
+!-- Calculate prognostic equation for chemical quantites
     IF ( air_chemistry )  THEN
        CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'start' )
@@ -2470,9 +2308,9 @@
 !--    Loop over chemical species
        DO  lsp = 1, nvar                         
-          CALL chem_prognostic_equations ( chem_species(lsp)%conc_p,           &
-                                           chem_species(lsp)%conc,             &
-                                           chem_species(lsp)%tconc_m,          &
-                                           chem_species(lsp)%conc_pr_init,     &
-                                           lsp )       
+          CALL chem_prognostic_equations( chem_species(lsp)%conc_p,            &
+                                          chem_species(lsp)%conc,              &
+                                          chem_species(lsp)%tconc_m,           &
+                                          chem_species(lsp)%conc_pr_init,      &
+                                          lsp )
        ENDDO
 
@@ -2480,4 +2318,7 @@
     ENDIF   ! Chemicals equations
 
+!
+!-- Calculate prognostic equations for the ocean
+    IF ( ocean_mode )  CALL ocean_prognostic_equations()
 
  END SUBROUTINE prognostic_equations_vector
